package jp.mosp.common.part;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import jp.mosp.common.CommonConst;

import jp.mosp.common.dto.CmAuthorityDto;
import jp.mosp.common.dto.CmComponentDto;
import jp.mosp.common.dto.HumanBasisDtoInterface;

import jp.mosp.system.dao.MSyozokuDao;
import jp.mosp.system.dto.MSyozokuDto;

/**
 * 所属に関するPartクラス
 * @author yoshida
 *	@version	0.0.1
 */
public class SectionPart extends BasePart {

	/**
	 * コンストラクタ
	 */
	public SectionPart() {
		super();
	}

	/**
	 * コンストラクタ
	 * @param partInfo
	 */
	public SectionPart(PartInfo partInfo) {
		super(partInfo);
	}

	/**
	 * M_SYOZOKUテーブル用のDAO取得
	 * @return	初期化済みMSyozokuDaoインスタンス
	 * @throws Exception
	 */
	public MSyozokuDao getMSyozokuDao() throws Exception {
		return (MSyozokuDao)getPreparedDao(MSyozokuDao.class.getCanonicalName());
	}

	/**
	 * 所属情報取得(M_SYOZOKU)
	 * @param sCode 情報取得対象所属コード
	 * @return 所属情報(MSyozokuDto)
	 * @throws Exception 
	 */
	public MSyozokuDto getSectionInfo(
			String sCode
	) throws Exception {
		// 情報の取得
		return getMSyozokuDao().findForKey(sCode);
	}

	/**
	 * 所属情報取得(M_SYOZOKU)
	 * @param sCode 情報取得対象所属コード
	 * @return 所属名称
	 * @throws Exception 
	 */
	public String getSectionName(
			String sCode
	) throws Exception {
		String sName = "";
		MSyozokuDto dto = getSectionInfo(sCode);
		if (dto != null) {
			sName = dto.getSName();
		}
		return sName;
	}

	/**
	 * 所属コード取得
	 * @param kCode 取得対象社員コード
	 * @return 所属コード
	 * @throws Exception
	 */
	public String getBelongSectionCode(
			String kCode
	) throws Exception {
		String strStationCode = "";
		// 人事基本情報取得
		HumanBasisDtoInterface mKihonDto = human().getBasisInfo(kCode);
		if (VariousPart.chkExistObject(mKihonDto)) {
			strStationCode = mKihonDto.getSCode();
			// 所属情報取得
			if (strStationCode.length() > 0) {
				MSyozokuDto dto = getMSyozokuDao().findForKey(strStationCode);
				if (VariousPart.chkExistDto(dto)) {
					strStationCode = dto.getSCode();
				} else {
					strStationCode = "";
				}
			}
		}
		return strStationCode;
	}

	/**
	 * 所属コード取得(M_SYOZOKU)
	 * @return 所属コードリスト
	 * @throws Exception 
	 */
	public String[][] getSectionArrayAll() throws Exception {
		// 情報の取得
		List<MSyozokuDto> listSection = getMSyozokuDao().findAll();
		// 配列の作成
		String[][] arySection = new String[listSection.size()][2];
		for (int i = 0; i < listSection.size(); i++) {
			arySection[i][0] = listSection.get(i).getSCode();
			arySection[i][1] = listSection.get(i).getSName();
		}
		return arySection;
	}

	/**
	 * 所属コード取得(利用可能…所属のみ)(M_SYOZOKU)
	 * @return 所属コードリスト
	 * @throws Exception
	 */
	public String[][] getSectionArrayForManager() throws Exception {
		// 情報の取得
		List<MSyozokuDto> listSection = getMSyozokuDao().findForCondition(
				getBelongSectionCode(human().getBasisInfoOfUser().getKCode())
		);
		// 配列の作成
		String[][] aryStation = new String[listSection.size()][2];
		for (int i = 0; i < listSection.size(); i++) {
			aryStation[i][0] = listSection.get(i).getSCode();
			aryStation[i][1] = listSection.get(i).getSName();
		}
		return aryStation;
	}

	/**
	 * 所属コード取得(利用可能…権限により変化)(M_SYOZOKU)
	 * @return 所属コードリスト
	 * @throws Exception
	 */
	public String[][] getSectionArrayForHuman() throws Exception {
		// 情報の取得
		List<MSyozokuDto> listSection;
		// 操作権限確認		
		if (authority().hasHumanAuth()) {
			listSection = getMSyozokuDao().findAll();
		} else {
			listSection = getMSyozokuDao().findForCondition(
					getBelongSectionCode(human().getBasisInfoOfUser().getKCode())
			);		
		}
		// 配列の作成
		String[][] aryStation = new String[listSection.size()][2];
		for (int i = 0; i < listSection.size(); i++) {
			aryStation[i][0] = listSection.get(i).getSCode();
			aryStation[i][1] = listSection.get(i).getSName();
		}
		return aryStation;
	}

	/**
	 * 所属コード取得(所属範囲により変化)(M_SYOZOKU)
	 * @return 所属コードリスト
	 * @throws Exception
	 */
	public String[][] getSectionScopeArrayForPayroll() throws Exception {
		CmComponentDto cmComponentDto = new CmComponentDto();
		String userAuth = user.getAuthority();
		CmAuthorityDto cmAuthorityDto = authority().findForKey(userAuth);
		String [][] ary = null ;
		if (cmAuthorityDto != null) {
			cmComponentDto = component().findForKey(cmAuthorityDto.getPayroll());
		}
		// デフォルトの設定
		if (userAuth.equals(CommonConst.AUTHORITY_CALCULATE)) {
			cmComponentDto.setManage(VariousPart.getManageCode()[2]);
		} else if (userAuth.equals(CommonConst.AUTHORITY_PAYROLL)) {
			cmComponentDto.setManage(VariousPart.getManageCode()[0]);
		}
		// プルダウン設定
		if (cmComponentDto.getManage() == VariousPart.getManageCode()[0]) {
			ary = getSectionArrayForManager();			
		} else if (cmComponentDto.getManage() == VariousPart.getManageCode()[1]) {
			ary = getSectionArrayAll();
		} else {
			ary = StringPart.addArrayFirstRowValue(
					getSectionArrayAll(),
					CommonConst.NAM_COMMON_STRING_INITIAL_VALUE,
					CommonConst.NAM_ALL_SECTION);
		}
		return ary;
	}

	/**
	 * 所属リスト取得(M_SYOZOKU)
	 * @return 所属コードリスト
	 * @throws Exception
	 */
	public Map<String, MSyozokuDto> getSectionMap() throws Exception {
		// 情報の取得
		List<MSyozokuDto> listSection = getMSyozokuDao().findAll();
		// 配列の作成
		HashMap<String, MSyozokuDto> map = new HashMap<String, MSyozokuDto>();
		for (int i = 0; i < listSection.size(); i++) {
			map.put(listSection.get(i).getSCode(), listSection.get(i));
		}
		return map;
	}

	/**
	 * 全所属コード配列取得
	 * @return	所属コード配列
	 * @throws Exception
	 */
	public String[] getSectionCodeArrayAll() throws Exception {
		List<MSyozokuDto> listSection = getMSyozokuDao().findAll();
		String[] arySectionCode = new String[listSection.size()];
		int i = 0;
		for (Iterator iter = listSection.iterator(); iter.hasNext();) {
			MSyozokuDto dto = (MSyozokuDto) iter.next();
			arySectionCode[i] = dto.getSCode();
			i++;
		}
		return arySectionCode;
	}

}
